	PROGRAM TEST
C
C ************* M A I N   D R I V E R   P R O G R A M.*************
C
C
C
C THIS PROGRAM TESTS ALL THE AVAILABLE ROUTINES FOR
C HEAVY WATER/VAPOUR SYSTEMS.
C
C
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)

	COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *	ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *	ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER

	COMMON /WASPR5/ F1,F2,F11,F12,F22,F21,TES1,TES2,TNEW,VNEW,TOLD,
     *                  VOLD,POLD,IS2

	CHARACTER TEXT1(7)*56, TEXT2(2,7)*3, TEXT3(7)*6


      	DATA TEXT1 /
     *  ' Enter Pressure (Pa) & Internal Energy (j/kg)  P,U =',
     *	' Enter Pressure (Pa) & Entropy (j/kg K)   P,S = ',
     *	' Enter Enthalpy (j/kg) & Pressure (Pa)   H,P = ',
     *	' Enter Pressure (Pa) & Temperature (Deg.C)   P,T = ',
     *	' Enter Pressure (Pa) & Volume (m3/kg)   P,V  = ',
     *	' Enter Enthalpy (j/kg) & Volume (m3/kg)   H,V = ',
     *	' Enter Internal Energy (j/kg) & Volume (m3/kg)   U,V = '/

	DATA TEXT2 /'P=','U=','P=','S=','H=','P=','P=','T=','P=','V=',
     *              'H=','V=','U=','V=' /
	
	DATA TEXT3 /'WASPU1','WASPS1','WASHP1','WASPT1','WASPV1',
     *              'WASHV1','WASUV1' /


	OPEN (3,FILE='LPT1')

	DO 30 I=1,50

	WRITE (*,20)
20	FORMAT (/,10X,'SELECT ONE',//,
     *            10X,'1-   P & U ',/,
     *            10X,'2-   P & S ',/,
     *            10X,'3-   H & P ',/,
     *            10X,'4-   P & T ',/,
     *            10X,'5-   P & V ',/,
     *            10X,'6-   H & V ',/,
     *            10X,'7-   U & V ',/)

	WRITE (*,'(A\)') '                    ENTER THE NUMBER PLEASE = '
	READ (*,*) K

	IF (K.LT.1 .OR. K.GT.7) GOTO 99


	WRITE (*,19)
 19	FORMAT (//////)

	WRITE (*,'(A\)') TEXT1(K)
	READ (*,*) VI1,VI2

	WRITE (*,19)

      WRITE (*,'(A\)') ' Enter L,  and Estimates of (T,V)    L,T,V = '
      READ (*,*) L,VO1,VO2
C
C  SAVE L IN LL FOR PRINTING LATER
C
      LL=L
	GOTO (1,2,3,4,5,6,7),K	

 1	CALL WASPU1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
        H=VI2+VI1*VO2
        U=VI2
	GOTO 25
 2	CALL WASPS1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
        U=Z-(VO1+ZZZ273)*Z1
        H=U+VI1*VO2
        GOTO 25
 3	CALL WASHP1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
        H=VI1
        U=H-VI2*VO2
	GOTO 25
 4	CALL WASPT1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
        U=Z-(VI2+ZZZ273)*Z1
        H=U+VI1*VO2
	GOTO 25
 5	CALL WASPV1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
        U=Z-(VO1+ZZZ273)*Z1
        H=U+VI1*VI2
	GOTO 25
 6	CALL WASHV1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
        H=VI1
        U=H+Z2*VI2
	GOTO 25
 7	CALL WASUV1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
        U=VI1
        H=U-Z2*VI2


 25	WRITE (3,26) TEXT3(K)
 26	FORMAT(/,10X,A,/,10X,'------',/)

	IF (LL.EQ.100) THEN
	WRITE (3,'(10X,A)')'LIQUID PHASE '
	ELSE 
	WRITE (3,'(10X,A)')'VAPOUR PHASE '
	ENDIF


      WRITE (3,27) TEXT2(1,K),VI1,TEXT2(2,K),VI2,VO1,VO2,Z,-Z1,-Z2,H,U
 27	FORMAT (/,10X,2(A,E20.8,/,10X),/,10X,' T= ',E20.8,/,10X,
     *  ' V= ',E20.8,/,10X,' Z= ',E20.8,/,10X,
     *  ' S= ',E20.8,/,10X,' P= ',E20.8,/,10X,
     *  ' H= ',E20.8,/,10X,' U= ',E20.8,///)


C --------------- DERIVATIVE SECTION.---------------
C  partial derivatives; ex: DVDHCP reads as Derivative of 
c  specific Volume with respect to entHalpy at Constant Pressure
C
      ABSTEM=VO1+ZZZ273
      TDENOM=ABSTEM*(Z12*Z12-Z11*Z22)
C
C DERIVATIVES OF SPECIFIC VOLUME.
C
      DVDHCP=-Z12/TDENOM
      DVDPCH=(ABSTEM*Z11+VO2*Z12)/TDENOM
C
C DERIVATIVES OF PRESSURE.
C
      DPDTCV=-Z12
      DPDVCT=-Z22
      DPDVCS=Z12*(Z12/Z11-Z22/Z12)
C
C DERIVATIVES OF ENTROPY.
C
      DSDTCV=-Z11
      DSDPCT=Z12/Z22
      DSDPCV=Z11/Z12
      DSDVCP=Z22*(Z11/Z12-Z12/Z22)
C
C DERIVATIVES OF ENTHALPY.
C
      DHDTCP=TDENOM/Z22
      DHDVCT=-(ABSTEM*Z12+VO2*Z22)
      DHDPCV=ABSTEM*Z11/Z12+VO2
C
C DERIVATIVES OF HEAT CAPACITY AT CONSTANT PRESSURE, CP, AND
C CONSTANT VOLUME, CV.
C
      CP=DHDTCP
      CV=DSDTCV*ABSTEM
C
C ISENTROPIC EXPANSION COEFFICIENT
C
      GAMMA=(DPDVCS/Z2)*VO2
C
C JOULE THOMSON COEFFICIENT
C
      DTDPCH=-(ABSTEM*Z12/Z22+VO2)/DHDTCP
C
C ACOUSTIC VELOCITY, M/SEC.
      XXX=VO2*VO2*Z12*(Z22/Z12-Z12/Z11)
      IF (XXX.LE.ZZZ0) XXX=0.0 
      ACOVEL=DSQRT(XXX)



      WRITE(3,40) DVDHCP,DVDPCH,DPDTCV,DPDVCT,DPDVCS,DSDTCV,DSDPCT,
     *            DSDPCV,DSDVCP,DHDTCP,DHDVCT,DHDPCV,DTDPCH,ACOVEL,
     *            CP,CV,GAMMA

  40  FORMAT(/,10X,'DVDHCP           = ',E20.8,/,10X,
     *             'DVDPCH           = ',E20.8,/,10X,
     *             'DPDTCV           = ',E20.8,/,10X,
     *             'DPDVCT           = ',E20.8,/,10X,
     *             'DPDVCS           = ',E20.8,/,10X,
     *             'DSDTCV           = ',E20.8,/,10X,
     *             'DSDPCT           = ',E20.8,/,10X,
     *             'DSDPCV           = ',E20.8,/,10X,
     *             'DSDVCP           = ',E20.8,/,10X,
     *             'DHDTCP           = ',E20.8,/,10X,
     *             'DHDVCT           = ',E20.8,/,10X,
     *             'DHDPCV           = ',E20.8,/,10X,
     *             'DTDPCH           = ',E20.8,/,10X,
     *             'ACOUSTIC VELOCITY= ',E20.8,/,10X,
     *             'CP               = ',E20.8,/,10X,
     *             'CV               = ',E20.8,/,10X,
     *             'Isentropic expansion coefficient = ',E20.8,////)
C
 30	CONTINUE
 99	STOP
	END


C
C -------- SUBROUTINES FOR THE HEAVY WATER/VAPOUR SYSTEM --------
C
C
        SUBROUTINE WASHP1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
C
C  THIS SUBROUTINE COMPUTES THE HELMHOLTZ FREE ENERGY FOR SINGLE
C  PHASE (LIG. OR VAPOUR) AS A FUNCTION OF ENTHALPY AND PRESSURE
C
C    MODIFIED BY HALDUN TEZEL 1986
C
C
C  PARAMETERS:
C  L    Number of iterations required for solution
C  VI1  Enthalpy, J/Kg
C  VI2  Pressure, Pa
C  VO1  Temperature, Deg.C
C  VO2  Specific volume, m3/Kg
C
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
        COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *  ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *  ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER
C
        COMMON /WASPR5/ F1,F2,F11,F12,F22,F21,TES1,TES2,TNEW,VNEW,TOLD,
     *                  VOLD,POLD,IS2
        POLD=VI2
        TNEW=VO1
        VNEW=VO2
        IS2=4
        TES1=ZZZER
        TES2=ZZZER
C
        CALL WASPR1 (1,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
  1     T=(TOLD+ZZZ273)
C
        F1=(Z-T*Z1-VOLD*Z2)-VI1
        F2=-(Z2+VI2)
        F11=-(T*Z11+VOLD*Z12)
        F12=-(T*Z12+VOLD*Z22)
        F21=-Z12
        F22=-Z22
C
        CALL WASPR1 (3,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
        IF (IRET.GT.0) GOTO 1
C
        RETURN
        END
C
C
C ===================================================================
C
C
        SUBROUTINE WASHV1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
C
C       VI1     H, j/kg
C       VI2     V, m3/kg
C       VO1     T, deg.C
C       VO2     V, m3/kg
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
        COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *  ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *  ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER
C
        COMMON /WASPR5/ F1,F2,F11,F12,F22,F21,TES1,TES2,TNEW,VNEW,TOLD,
     *                  VOLD,POLD,IS2
C
C
        TNEW=VO1
        VNEW=VI2
        VO2=VI2
        VOLD=VI2
C
        IS2=8
C
        TES1=ZZZER
        TES2=ZZZ1
        F12=ZZZ0
        F21=ZZZ0
        F22=ZZZ1
        F2=ZZZ0
C
        CALL WASPR1 (1,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
 1      T=(TOLD+ZZZ273)
        F1=(Z-T*Z1-VOLD*Z2)-VI1
        F11=(-T*Z11-VOLD*Z12)
C
        CALL WASPR1 (3,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
        IF (IRET.GT.ZZZ0) GOTO 1
C
 99     RETURN
        END
C
C
C ====================================================================
C
C
        SUBROUTINE WASPS1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
C
C       VI1     P
C       VI2     S
C       VO1     T
C       VO2     V
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
        COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *  ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *  ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER
C
        COMMON /WASPR5/ F1,F2,F11,F12,F22,F21,TES1,TES2,TNEW,VNEW,TOLD,
     *                  VOLD,POLD,IS2
C
        POLD=VI1
        TNEW=VO1
        TOLD=TNEW
        VNEW=VO2
        VOLD=VNEW
C
        IS2=2
C
        TES1=ZZZER
        TES2=ZZZER
C
        CALL WASPR1 (1,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
 1      F1=(-Z2-VI1)
        F2=(-Z1-VI2)
        F11=-Z12
        F12=-Z22
        F21=-Z11
        F22=-Z12
C
        CALL WASPR1 (3,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
        IF (IRET.GT.ZZZ0) GOTO 1
C
 99     RETURN
        END
C
C
C ====================================================================
C
C
        SUBROUTINE WASPT1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
C
C  THIS ROUTINE EVALUATES THE WATER/VAPOUR PROPERTIES AS A FUNCTION
C  OF PRESSURE AND TEMPERATURE
C
C       VI1     PRESSURE
C       VI2     TEMPERATURE
C       VO1     TEMPERATURE
C       VO2     SPECIFIC VOLUME      GIVE AN APPROXIMATE VALUE
C       L       NUMBER OF ITERATIONS AND IF EITHER TNEW OR VNEW IS
C               LESS THAN ZERO WASPR1 CALLS WASIN1 WHICH EVALUATES
C               LIQUID (L=100) OR VAPOUR (L=200) PROPERTIES.
C
C       IN THE FINAL RETURN               Tnew WILL BE IN VO1
C       FROM THIS SUBROUTINE              Vnew WILL BE IN VO2
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
        COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *  ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *  ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER
C
        COMMON /WASPR5/ F1,F2,F11,F12,F22,F21,TES1,TES2,TNEW,VNEW,TOLD,
     *                  VOLD,POLD,IS2
C
        POLD=VI1
        TOLD=VI2
        VO1=VI2
        VNEW=VO2
        IS2=3
        TES1=ZZZM4
        TES2=ZZZM2
        TNEW=TOLD
        F11=ZZZ1
        F2=ZZZ0
        F21=ZZZ1
        F22=ZZZ0
C
        CALL WASPR1(1,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
 1      F1=Z2+VI1
        F12=Z22
C
        CALL WASPR1(3,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
        IF (IRET.GT.ZZZ0) GOTO 1
C
        RETURN
        END
C
C
C ====================================================================
C
C
        SUBROUTINE WASPU1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
C
C       VI1     P, Pa
C       VI2     U, j/kg
C       VO1     T, deg.C
C       VO2     V, m3/kg
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
        COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *  ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *  ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER
C
        COMMON /WASPR5/ F1,F2,F11,F12,F22,F21,TES1,TES2,TNEW,VNEW,TOLD,
     *                  VOLD,POLD,IS2
C
C
        POLD=VI1
        TNEW=VO1
        VNEW=VO2
        NS=1
C
        IS2=7
C
        NX=L
        TES1=ZZZER
        TES2=ZZZER
C
        CALL WASPR1 (1,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
 1      T=(TOLD+ZZZ273)
        F1=(-Z2-VI1)
        F2=(Z-T*Z1)-VI2
        F11=-Z12
        F12=-Z22
        F21=-T*Z11
        F22=(Z2-T*Z12)
C
        CALL WASPR1 (3,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
        IF (IRET.GT.ZZZ0) GOTO 1
C
 99     RETURN
        END
C
C
C ====================================================================
C
C
        SUBROUTINE WASPV1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
C
C       VI1     P, Pa
C       VI2     V, m3/kg
C       VO1     T, deg.C
C       VO2     V, m3/kg
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
        COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *  ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *  ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER
C
        COMMON /WASPR5/ F1,F2,F11,F12,F22,F21,TES1,TES2,TNEW,VNEW,TOLD,
     *                  VOLD,POLD,IS2
C
        POLD=VI1
        VOLD=VI2
        TNEW=VO1
        VO2=VI2
C
        IS2=6
C
        NX=L
        VNEW=VOLD
        TES1=ZZZER
        TES2=ZZZ1
        F12=ZZZ1
        F2=ZZZ0
        F21=ZZZ0
        F22=ZZZ1
C
        CALL WASPR1 (1,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
 1      F1=-Z2-VI1
        F11=-Z12
C
        CALL WASPR1 (3,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
        IF (IRET.GT.ZZZ0) GOTO 1
C
 99     RETURN
        END
C
C
C ====================================================================
C
C
        SUBROUTINE WASUV1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
C
C       VI1     U
C       VI2     V
C       VO1     T
C       VO2     V
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
        COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *  ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *  ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER
C
        COMMON /WASPR5/ F1,F2,F11,F12,F22,F21,TES1,TES2,TNEW,VNEW,TOLD,
     *                  VOLD,POLD,IS2
C
        VOLD=VI2
        VNEW=VOLD
        TNEW=VO1
        TOLD=TNEW
C
        IS2=1
C
        TES1=ZZZM5
        TES2=ZZZ1
C
        F12=ZZZ1
        F2=ZZZ0
        F21=ZZZ0
        F22=ZZZ1
C
        CALL WASPR1 (1,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
 1      T=(TOLD+ZZZ273)
        F1=(Z-T*Z1)-VI1
        F11=-T*Z11
C
        CALL WASPR1 (3,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
        IF (IRET.GT.ZZZ0) GOTO 1
C
 99     RETURN
        END
C
C
C ::::::::::::::::::::::: SUB-SUBROUTINES ::::::::::::::::::::::::::::
C
C
        SUBROUTINE WASAP1 (VAR1,VAR2,QUO)
C
C  SATURATION LINE EQUATION. SOURCE: 1968 IFC FORMULATION
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
        COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *  ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *  ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER
C
        DIMENSION A(5),AK(12),TU(12),DTU(12)
C
        DATA A /1.0002D0,1.3464D-1,1.49919D-2,1.01085D-3,2.9045D-5/
C
        DATA AK /-4.0596821D0,5.1322555D0,-1.1842407D0,1.1779592D-1,
     *  -5.157642D-3,-1.4689537D-3,5.3622818D-4,1.2455399D-4,
     *  -4.9154288D-5,4.6302565D-5,1.5301334D-5,-2.095453D-5/
C
        DATA XK1,XK2,XK3 /9.5D-1,1.45220717D0,-8.4878953D-1/
C
        ITEMPS=0
        IF (VAR2.GT.ZZZM2 .OR. VAR2.LT.374.15D0) GOTO 51
        IF (VAR2.LE.ZZZM2) VAR1=611.3D-5
        IF (VAR2.GE.374.15D0) VAR1=220.9D5
        ITERM=5
C
C       KERLV=5                    THESE ARE ERROR MESSAGES
C       ERRMES(1)=SNAME
C       ERRMES(2)=VAR2
C       CALL TERMN1
C
        GOTO 99
 51     CONTINUE
        THETA=(VAR2+ZZZ273)/643.89D0
        U=(ZZZ2*(ZZZ1/THETA-XK1)**0.4D0-XK2)/XK3
        TU(1)=ZZZ1
        TU(2)=U
C
        DO 10 I=3,12
        J=I-1
        K=I-2
 10     TU(I)=ZZZ2*U*TU(J)-TU(K)
C
        SUM=ZZZ0
        DO 20 I=1,12
 20     SUM=SUM+AK(I)*TU(I)
C
        BETAK=DEXP(SUM)
        PSF=BETAK*2.166D7
        DU=-ZZZ1*0.4D0*ZZZ2/(XK3*(ZZZ1/THETA-XK1)**0.6D0*THETA**2)
        DTU(1)=ZZZ0
        DTU(2)=DU
C
        DO 30 I=3,12
        J=I-1
        K=I-2
 30     DTU(I)=ZZZ2*(DU*TU(J)+U*DTU(J))-DTU(K)
C
        DSUM=ZZZ0
        DO 40 I=1,12
 40     DSUM=DSUM+AK(I)*DTU(I)
C
        DBETAK=BETAK*DSUM
        QUO=DBETAK*2.166D7/643.89D0
        IF (ITEMPS.EQ.0) GOTO 45
        GOTO 12
C
        ENTRY WASATI (VAR1,VAR2,QUO)
        IF (VAR1.GT.611.73D0 .OR. VAR1.LT.220.55D5) GOTO 3
C
C       ITERM=5                  ERROR MESSAGES
C       KERLV=5
C       ERRMES(1)=SNAM2
C       ERRMES(2)=VAR1
C
        IF (VAR1.LT.611.73D0) VAR2=ZZZM2
        IF (VAR1.GE.220.55D5) VAR2=370.74D0
C
C       CALL TERMN1              ERROR MESSAGE SUBROUTINE
C
        GOTO 99
 3      ITEMPS=1
        NDEG=4
        SUM=ZZZ0
        FUN=DLOG(VAR1/2.212D7)
C
        DO 1 I=1,NDEG
        J=NDEG+2-I
        SUM=FUN*(A(J)+SUM)
 1      CONTINUE
C
        THETA=A(I)+SUM
        VAR2=THETA*643.89D0-ZZZ273
        I=1
        GOTO 51
C
 12     CONTINUE
        ZDELTE=(PSF-VAR1)/QUO
        VAR2=VAR2-ZDELTE
        DIF=DABS((VAR1-PSF)*ZZZE2/VAR1)
        PTEST=1.0D-5
        IF (DIF.LE.PTEST) GOTO 99
        I=I+1
        IF (I.GE.20) GOTO 31
        GOTO 51
C
 31     CONTINUE
 45     CONTINUE
        VAR1=PSF
C
 99     RETURN
        END
C
C
C ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C
        SUBROUTINE WASIN1 (VI1,VI2,VO1,VO2,L)
C
C  THIS SUBROUTINE PROVIDES INITIAL ESTIMATES OF TEMPERATURE
C  AND SPECIFIC VOLUME AS FUNCTIONS OF VI1 AND VI2
C
C  PARAMETERS:
C       L       Parameter to be used only if the independent
C               variables are Pressure and Temperature.
C               Then if;
C               L=100 ----> Vold calculated from subcooled lig.
C               L=200 ----> Vold calculated from superheated vap.
C               corresponding to VI1 and VI2.
C
C       TOLD    Temperature, Deg.C
C       VOLD    Specific volume, m3/Kg
C       VI1     First independent variable
C       VI2     Second independent variable
C
C  LOCAL VARIABLES:
C       POLD    Last value of pressure, Pa
C       PSATF   Saturation pressure at temperature TOLD, Pa
C       PSL     Pressure at water region at TOLD, Pa
C       PX      An arbitrary pressure close to critical press.
C               and set to 2E7, Pa
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
        COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *  ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *  ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER
C
        COMMON /WASPR5/ F1,F2,F11,F12,F22,F21,TES1,TES2,TNEW,VNEW,TOLD,
     *                  VOLD,POLD,IS2
C
C
C  THE FOLLOWING TWO ARE FUNCTIONS TO BE INSERTED
C
C       $INCLUDE:'WASTD1.FOR'
C       $INCLUDE:'WASTL1.FOR'
C
        DATA AL0,AL1,AL2 /1.574373327D1,-3.417061978D1,1.931380707D1/
C
        TOLD=VO1
C
C  CALCULATE AN INITIAL SPECIFIC VOLUME
C
        IF (L.EQ.100) GOTO 46
        IF (L.EQ.200) GOTO 45
        T=(TOLD+ZZZ273)/643.89D0
        PSATF=0.0D0
        PSL=0.0D0
C
        IF (T.LE.1.0)  CALL WASAP1 (PSATF,TOLD,QUO)
        IF (T.GT.0.96269) PSL=(AL0+T*(AL1+T*AL2))
        IF (POLD.GT.PSL .AND. T.GT.0.96269) GOTO 40
        IF (T.LT.0.96269) GOTO 44
C
 45     CONTINUE
        PX=2.0D7
        IF (POLD.GT.PX .AND. TOLD.LT.370.74) GOTO 50
        VO2=WASTD1(POLD,TOLD)
        GOTO 99
 40     CONTINUE
        IF (T.GT.1.001) GOTO 42
        IF (POLD.GT.PSATF) GOTO 43
 44     CONTINUE
        IF (POLD.LE.PSATF) GOTO 45
 46     CONTINUE
        VO2=WASTL1(POLD,TOLD)
        GOTO 99
 42     CONTINUE
        VO2=WASTD1(PSL,TOLD)*PSL/POLD
        GOTO 99
 43     CONTINUE
        VO2=0.7336218
        GOTO 99
 50     CONTINUE
        VO2=(4.6515D-3)*(2.137D7/POLD)**3
C
 99     RETURN
        END
C
C
C ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C
      SUBROUTINE WASPR1(IGO,VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L,IRET)
C
C
C      CONVERGENCE CRITERIA HAS BEEN BUILD INTO THIS ROUTINE
C      MODIFIED BY HALDUN TEZEL 1986
C
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
        COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *  ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *  ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER
C
        COMMON /WASPR5/ F1,F2,F11,F12,F22,F21,TES1,TES2,TNEW,VNEW,TOLD,
     *                  VOLD,POLD,IS2
C
        CHARACTER ALX2(8)*2
        DATA ALX2 /'UV','PS','PT','HP','TP','PV','PU','HV'/
C
        GOTO (1,2,3),IGO
 1      IF (TNEW.GE.ZZZ0 .AND. VNEW.GT.ZZZ0) GOTO 5
C
        CALL WASIN1 (VI1,VI2,TNEW,VNEW,L)
C
C       VO1=TNEW
C       VO2=VNEW
C
 5      TOLD=TNEW
        VOLD=VNEW
 2      CONTINUE
        L=1
        GOTO 260
 3      IRET=0
        DENOM=F11*F22-F12*F21
        ZDELTE=-(F1*F22-F2*F12)/DENOM
        DELV=-(F2*F11-F1*F21)/DENOM
        TNEW=TOLD+ZDELTE
        VNEW=VOLD+DELV
        IF (VNEW.LT.ZZZM4) VNEW=ZZZM4
        DIFF=DABS(F1*ZZZE2/VI1)
        DIF1=DABS(F2*ZZZE2/VI2)
        TOLD=TNEW
        VOLD=VNEW
C
C  CHECK FOR TERMINATION
C
        IF (DIFF.LT.TES1 .AND. DIF1.LT.TES2) GOTO 370
        IF (L.GT.1000) GOTO 4
 260    CONTINUE
C
        CALL WASR21 (TOLD,VOLD,Z,Z1,Z2,Z11,Z12,Z22)
C
        L=L+1
        IRET=1
        GOTO 99
 4      WRITE (*,100) L,VI1,VI2,VO1,VO2,TNEW,VNEW
        GOTO 99
 370    CONTINUE
        VO1=TNEW
        VO2=VNEW
C
  100   FORMAT(/,10X,'NO CONVERGENCE AFTER ',I5,' ITERATIONS',/,
     *           10X,'VI1 =',F14.4,/,
     *           10X,'VI2 =',F14.4,/,
     *           10X,'VO1 =',F14.6,/,
     *           10X,'VO2 =',F14.6,/,
     *           10X,'TNEW=',F14.6,/,
     *           10X,'VNEW=',F14.6/)
C
 99     RETURN
        END
C
C
C ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C
      SUBROUTINE WASR21 (TCENT,V,F,DFDT,DFDV,DFDTT,DFDTV,DFDVV)
C
C   HELMHOLTZ FUNCTION AND ITS DERIVATIVES FOR WATER AS A FUNCTION OF
C   TEMPERATURE AND SPECIFIC VOLUME
C   MODIFIED BY HALDUN TEZEL 1986
C   CONSTANTS ARE TAKEN FROM P.G.HILL, R.D.MACMILLAN, VICTOR LEE.
C   AECL 7531, 'TABLES OF THERMODYNAMIC PROPERTIES OF HEAVY WATER
C   IN S.I. UNITS.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION AC(8),A(10,7),TAJ(7),RAJ(7)
C
        COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *  ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *  ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER
C
C       THE FOLLOWING ARE THE COEFFICIENTS Ci's.
C
        DATA AC/1.86673D3,4.6619D3,6.4605D1,-2.848833D2,
     *  1.001333D2, -1.3135D1, 3.2684D-1, -1.211253D3/
C
C       THE FOLLOWING ARE THE COEFFICIENTS Ai's.
C
       DATA A/73.13848592D0,-285.20415917D0,535.71659288D0,
     *  -649.81000614D0,574.63280680D0,-387.92157774D0,206.34569512D0,
     *  -79.89428513D0,-996.36169097D0,-766.27290006D0,24.74108348D0,
     *  -105.57317181D0,200.87302906D0,-235.18776440D0,224.56976938D0,
     *  -40.09924297D0,128.77154771D0,-28.40907978D0,-1389.08003142D0,
     *  -1672.09705556D0,11.64775625D0,-42.51820251D0,72.45541064D0,
     *  -82.55391089D0,4*0.0D0,-267.85482520D0,-998.64982710D0,
     *  2.66566642D0,-9.19657655D0,15.13096920D0,-7.24860975D0,
     *  4*0.0D0,-46.83904320D0,-227.34793319D0,-6.73408249D0,
     *  24.03602093D0,-41.08079830D0,45.39111005D0,4*0.0D0,
     *  139.21659329D0,566.02305152D0,-5.24802962D0,18.52690633D0,
     *  -31.42397369D0,26.43208802D0,4*0.0D0,96.31411481D0,
     *  453.20280933D0,-1.17583447D0,4.13816432D0,-6.55842224D0,
     *  4.75774631D0,4*0.0D0,19.39184297D0,103.56819758D0/
C
        DATA R,TC,E/0.41515D0,1.553D0,4.3D0/
        DATA TAJ/1.553D0,6*2.53D0/
        DATA RAJ/0.7D0,6*1.1D0/
C
        EPS3=1.0D-20
        T=TCENT+ZZZ273
        VN=V*ZZZE3
        RH=ZZZ1/VN
        TA=ZZZE3/T
        DTA=-TA/T
        D2TA=-ZZZ2*DTA/T
        ALT=DLOG(T)
        ALR=DLOG(RH)
        ER=DEXP(-RH*E)
        TAD=TA-TC
C
        S1=ZZZ0
        S2=ZZZ0
        S3=ZZZ0
C
        DO 2 I=1,6
        XI=I
        TAI=TA**I
        S1=S1+AC(I)*TA/TAI
        S2=S2+AC(I)*(ZZZ1-XI)/TAI
        S3=S3+AC(I)*XI*(XI-ZZZ1)/(TAI*TA)
   2    CONTINUE
C
        P0=S1+ALT*(AC(7)+AC(8)/TA)
        DP0=S2*DTA+AC(7)/T+AC(8)*(ZZZM3-ALT*DTA/(TA*TA))
        D2P0=S3*DTA*DTA+D2TA*S2-AC(7)/(T*T)+AC(8)/(TA*T*T)
C
        S1=ZZZ0
        S2=ZZZ0
        S3=ZZZ0
        S4=ZZZ0
        S5=ZZZ0
        S6=ZZZ0
C
        DO 3 J=1,7
        XJ=J
        TD=TA-TAJ(J)
        RD=RH-RAJ(J)
                IF (DABS(RD).LT.EPS3)  RD=EPS3
        T1=TD**(J-2)
        T2=(J-2)*T1/TD
        T3=(J-3)*T2/TD
C
        S11=ZZZ0
        S12=ZZZ0
        S13=ZZZ0
        B=ZZZ1
C
        DO 4 I=1,8
        XI=I
        GIJ=A(I,J)*B
        DGIJ=GIJ*(XI-ZZZ1)/RD
        D2GIJ=DGIJ*(XI-ZZZ2)/RD
        S11=S11+GIJ
        S12=S12+DGIJ
        S13=S13+D2GIJ
        B=B*RD
  4     CONTINUE
C
        HIJ=A(9,J)+RH*A(10,J)
        S11=S11+ER*HIJ
        S12=S12+ER*(-E*HIJ+A(10,J))
        S13=S13+ER*(E*E*HIJ-ZZZ2*E*A(10,J))
C
        S1=S1+T1*S11
        S2=S2+T2*S11
        S3=S3+T3*S11
        S4=S4+T1*S12
        S5=S5+T1*S13
        S6=S6+T2*S12
C
  3     CONTINUE
C
C  FORMULATION OF Q, FIRST AND SECOND DERIVATIVE OF Q
C
        Q=TAD*S1
        DQDT=(S1+TAD*S2)*DTA
        DQDTT=(S1+TAD*S2)*D2TA+(ZZZ2*S2+TAD*S3)*DTA*DTA
        DQDR=TAD*S4
        DQDRR=TAD*S5
        DQDTR=DTA*(S4+TAD*S6)
C
C  FORMULATION OF THE HELMHOLTZ FREE ENERGY 'P(T,V)'
C
        P=P0+R*T*(ALR+RH*Q)
C
C  DERIVATIVES OF THE HELMHOLTZ FREE ENERGY
C
        DPDT=DP0+R*(ALR+RH*Q+T*RH*DQDT)
        DPDR=R*T*(ZZZ1/RH+Q+RH*DQDR)
        DPDTT=D2P0+R*RH*(ZZZ2*DQDT+T*DQDTT)
        DPDTR=R*(ZZZ1/RH+Q+RH*DQDR+T*(DQDT+RH*DQDTR))
        DPDRR=R*T*(-ZZZ1/(RH*RH)+ZZZ2*DQDR+RH*DQDRR)
        F=P*ZZZE3
        DFDT=DPDT*ZZZE3
        DFDV=-RH*RH*DPDR*ZZZE6
        DFDTT=DPDTT*ZZZE3
        DFDTV=-RH*RH*DPDTR*ZZZE6
        DFDVV=RH*RH*RH*(RH*DPDRR+ZZZ2*DPDR)*ZZZE3*ZZZE6
C
        RETURN
        END
C
C
C .................... DOUBLE PRECISION FUNCTIONS ....................
C
C
        DOUBLE PRECISION FUNCTION WASTD1 (PSF,TCENT)
C
C  DERIVATIVE OF THE B-FUNCTION WRT PRESSURE.  THE FUNCTION RETURNS
C  THE SPECIFIC VOLUME OF VAPOUR
C  SOURCE:  IFC FORMULATION FOR INDUSTRIAL AND SCIENTIFIC USE.
C  SECTION 6.2.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
        COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *  ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *  ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER
C
        DATA AL0,AL1,AL2/1.574373327D01,-3.417061978D01,1.931380707D01/
C
        DATA XI1,SMALLB /4.260321148D0,0.76333333333D0/
C
        DATA B11,B12,B21,B22,B23,B31,B32,B41,B42,B51,B52,B53,B61,B62,
     *  B71,B72,B81,B82,B90,B91,B92,B93,B94,B95,B96 /
     *  6.670375918D-2,1.388983801D0,8.390104328D-2,2.614670893D-2,
     *  -3.373439453D-2,4.520918904D-1,1.069036614D-1,-5.975336707D-1,
     *  -8.847535804D-2,5.958051609D-1,-5.159303373D-1,2.075021122D-1,
     *  1.190610271D-1,-9.867174132D-2,1.683998803D-1,-5.809438001D-2,
     *  6.522390126D-3,5.710218649D-4,1.936587558D2,-1.388522425D3,
     *  4.126607219D3,-6.508211677D3,5.745984054D3,-2.693088365D3,
     *  5.235718623D2 /
C
        DATA BB61,BB71,BB81,BB82
     * /4.006073948D-1,8.636081627D-2,-8.532322921D-1,3.460208861D-1/
C
        THETA=(TCENT+ZZZ273)/647.3
        BETAK=PSF/2.212D7
        QUANT=ZZZ1-THETA
        BETAL=AL0+THETA*(AL1+THETA*AL2)
        BIGX=DEXP(SMALLB*QUANT)
        TERM1=XI1*THETA/BETAK
C
        SA1=B11*BIGX**13+B12*BIGX**3
        SA2=B21*BIGX**18+B22*BIGX**2+B23*BIGX
        SA3=B31*BIGX**18+B32*BIGX**10
        SA4=B41*BIGX**25+B42*BIGX**14
        SA5=B51*BIGX**32+B52*BIGX**28+B53*BIGX**24
        TERM2=SA1+BETAK*(ZZZ2*SA2+BETAK*(ZZZ3*SA3+BETAK*(ZZZ4*SA4+
     *  BETAK*ZZZ5*SA5)))
C
        DEN=(ZZZ1/BETAK**4+BB61*BIGX**14)**2
        TOP=B61*BIGX**12+B62*BIGX**11
        PART1=TOP*ZZZ4/(DEN*BETAK**5)
        DEN=(ZZZ1/BETAK**5+BB71*BIGX**19)**2
        TOP=B71*BIGX**24+B72*BIGX**18
        PART2=TOP*ZZZ5/(DEN*BETAK**6)
        DEN=(ZZZ1/BETAK**6+BB81*BIGX**54+BB82*BIGX**27)**2
        TOP=B81*BIGX**24+B82*BIGX**14
        PART3=TOP*ZZZ6/(DEN*BETAK**7)
        TERM3=PART1+PART2+PART3
C
        SA1=B90+B91*BIGX+B92*BIGX**2+B93*BIGX**3+B94*BIGX**4+
     *      B95*BIGX**5+B96*BIGX**6
        TERM4=11.0D0*SA1*(BETAK/BETAL)**10
        DZDP=TERM1-TERM2-TERM3+TERM4
C
        WASTD1=DZDP*3.17D-3
C
 99     RETURN
        END
C
C
C ....................................................................
C
C
        DOUBLE PRECISION FUNCTION WASTL1 (PSF,TCENT)
C
C SPECIFIC VOLUME OF WATER AS A FUNCTION OF PRESSURE AND TEMPERATURE
C SOURCE: 1968 IFC FORMULATION FOR SCIENTIFIC AND GENERAL USE.
C Section 6.1 The A-Function
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
        COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *  ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *  ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER
C
        DATA A11,A12,A13,A14,A15,A16,A17,A18,A19,A20,A21,A22 /
     *  7.982692717D0,-2.616571843D-2,1.52241179D-3,2.284279054D-2,
     *  2.421647003D2,1.269716088D-10,2.074838328D-7,2.174020353D-8,
     *  1.105710498D-9,1.293441934D1,1.308119072D-5,6.047626338D-14 /
C
        DATA S1,S2,S3,S4,S5,S6,S7,S8,S9,S10,S11,S12 /
     *  8.438375405D-1,5.362162162D-4,1.72D0,7.342278489D-2,
     *  4.97585887D-2,6.537154300D-1,1.15D-6,1.5108D-5,
     *  1.4188D-1,7.002753165D0,2.995284926D-4,2.04D-1 /
C
        T=(TCENT+ZZZ273)/647.3D0
        BETAK=PSF/2.212D7
        Y=ZZZ1-S1*T**2-S2/T**6
        SUM4=S3*Y**2-ZZZ2*S4*T+ZZZ2*S5*BETAK
        IF (SUM4.LT.ZZZ0) GOTO 5
        Z=Y+DSQRT(SUM4)
        GOTO 6
C
 5      CONTINUE
        Z=Y
 6      CONTINUE
        POWER=ZZZ5/17.0D0
C
C   CALCULATE THE GIBBS FREE ENERGY DERIVATIVE WRT PRESSURE
C
        TERM1=A11*S5/Z**POWER
        TERM2=A12+A13*T+A14*T**2+A15*(S6-T)**10+A16/(S7+T**19)
        TERM3=(A17+ZZZ2*A18*BETAK+ZZZ3*A19*BETAK**2)/(S8+T**11)
        TERM4=(S11-ZZZ3/(S10+BETAK)**4)*A20*T**18*(S9+T**2)
        TERM5=ZZZ3*A21*(S12-T)*BETAK**2
        TERM6=ZZZ4*A22*BETAK**3/T**20
C
        DZDB=TERM1+TERM2-TERM3-TERM4+TERM5+TERM6
        WASTL1=DZDB*3.170D-3
C
 99     RETURN
        END
C
C
C ---------- COMMON BLOCK DATA TO THE MAIN AND SUBROUTINES -----------
C
C
      BLOCK DATA
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     * ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     * ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER
C
      COMMON /WASPR5/ F1,F2,F11,F12,F22,F21,TES1,TES2,TNEW,VNEW,TOLD,
     * VOLD,POLD,IS2
C
      DATA ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     * ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     * ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER/0.0D0,1.0D0,2.0D0,
     * 3.0D0,4.0D0,5.0D0,6.0D0,7.0D0,8.0D0,9.0D0,1.0D+2,1.0D+3,1.0D+4,
     * 1.0D+5,1.0D+6,1.0D-2,1.0D-3,1.0D-4,1.0D-5,1.0D-6,1.0D-1,
     * 1.0D+1,273.15D0,3.141592654D0,9.81D0,1.0D-4/
C
        END
